unit ausgleichU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TfrmAusgleich = class(TForm)
    picU: TPaintBox;
    cmdStart: TButton;
    cmdNeu: TButton;
    RadioGroup1: TRadioGroup;
    optRC: TRadioButton;
    optRL: TRadioButton;
    optRLC: TRadioButton;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    txtR: TEdit;
    txtC: TEdit;
    txtL: TEdit;
    txtTmax: TEdit;
    picI: TPaintBox;
    txtdeltaT: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    procedure cmdStartClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cmdNeuClick(Sender: TObject);
    procedure picUPaint(Sender: TObject);
    procedure picIPaint(Sender: TObject);
    procedure spule(R, L: double);
    procedure kondensator(R, C: double);
    procedure reihenschwingkreis(R, L, C:double);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;
const
  xmax=730;
  xmax2=xmax div 2;
  ymax=200;
  ymax2=ymax div 2;
var
    sx,t,tmax,dt,Ue:double;
    frmAusgleich: TfrmAusgleich;
    implementation

{$R *.DFM}
//-----------------------------------------------------------------------------
procedure TfrmAusgleich.Kondensator(R, C: double);
var
i,uc,uR: double;
begin
tmax := StrToFloat(txtTmax.Text);
sx:=xmax/tmax;
i:=0;uc:=0;t:=0;
picU.canvas.MoveTo(0,ymax2);
picI.canvas.MoveTo(0,round(ymax2-Ue/R));
picU.Canvas.Pen.Color:=clBlue;
picI.Canvas.Pen.Color:=clRed;
while(t < tmax) do
begin
t:=t+dt;
if(t>tmax/2) then Ue:=0;
uR:=Ue-uc;
i:=uR/R;
uc := uc + i * dt / C;
picU.canvas.Lineto(round(sx*t),round(ymax2-uc));
picI.canvas.Lineto(round(sx*t),round(ymax2-i));
end;
end;
//----------------------------------------------------------------------------
procedure TfrmAusgleich.Spule(R, L: double);
var
i, uL, uR: double;
begin
tmax := StrToFloat(txtTmax.Text);
sx:= xmax / tmax ;
i:=0;uL:=0;t:=0;
picU.canvas.MoveTo(0,round(ymax2-Ue));
picI.canvas.MoveTo(0,ymax2);
picU.Canvas.Pen.Color:=clBlue;
picI.Canvas.Pen.Color:=clRed;
while (t< tmax) do
begin
t:=t+dt;
if(t>tmax/2) then Ue:=0;
uL := Ue - uR;
i := i + uL*dt/L;
uR:=R*i;
picU.canvas.Lineto(round(sx*t),round(ymax2-uL));
picI.canvas.Lineto(round(sx*t),round(ymax2-i));
end;
end;
//-----------------------------------------------------------------------------
procedure TfrmAusgleich.Reihenschwingkreis(R, L, C:double);
var
i, uc, uL, uR: double;
begin
tmax := StrToFloat(txtTmax.Text);
sx := xmax / tmax ;
i:=0;uc:=0; uL:=0;t:=0;
picU.canvas.MoveTo(0,ymax2);
picI.canvas.MoveTo(0,ymax2);
picU.Canvas.Pen.Color:=clBlue;
picI.Canvas.Pen.Color:=clRed;
while(t< tmax)do
begin
t:=t+dt;
if(t>tmax/2) then Ue:=0;
uc := uc + i * dt / C;
i := i + uL*dt/L;
uR:=R*i;
uL:=Ue-uR-uc;
picU.canvas.Lineto(round(sx*t),round(ymax2-uc));
picI.canvas.Lineto(round(sx*t),round(ymax2-i));
end;
end;
//-----------------------------------------------------------------------------
procedure TfrmAusgleich.cmdStartClick(Sender: TObject);
var
R, C, L:double;
begin
Ue:=80;
R:=StrToFloat(txtR.Text);
C:=StrToFloat(txtC.Text);
L:=StrToFloat(txtL.Text);
dt:=StrToFloat(txtDeltaT.Text);
if(optRC.checked=true) then Kondensator(R,C)
else if(optRL.checked=true) then Spule(R,L)
else if(optRLC.checked=true) then Reihenschwingkreis(R,L,C);
end;
//-----------------------------------------------------------------------------
procedure TfrmAusgleich.FormCreate(Sender: TObject);
begin
picU.Width:=xmax;
picU.Height:=ymax;
picI.Width:=xmax;
picI.Height:=ymax;
end;
//-----------------------------------------------------------------------------
procedure TfrmAusgleich.cmdNeuClick(Sender: TObject);
begin
frmAusgleich.picU.refresh;
frmAusgleich.picI.refresh;
end;
//-----------------------------------------------------------------------------
procedure TfrmAusgleich.picUPaint(Sender: TObject);
begin
frmAusgleich.picU.canvas.Pen.Color:=clBlack;
frmAusgleich.picU.canvas.rectangle(0,0,xmax,ymax);
frmAusgleich.picU.Canvas.MoveTo(0,ymax2);
frmAusgleich.picU.Canvas.LineTo(xmax,ymax2);
end;
procedure TfrmAusgleich.picIPaint(Sender: TObject);
begin
frmAusgleich.picI.canvas.Pen.Color:=clBlack;
frmAusgleich.picI.canvas.rectangle(0,0,xmax,ymax);
frmAusgleich.picI.Canvas.MoveTo(0,ymax2);
frmAusgleich.picI.Canvas.LineTo(xmax,ymax2);
end;
end.

